<?php
# Copyright (C) 2011 Matthew Wronka <murder@projects.matt.wronka.org>
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, version 3 of the
# License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>

$GLOBALS['CONFIG'] = array(); // this might become an object in the future
function config($key, $module='CORE', $value=null)
{
	if($value === null)
	{
		return $GLOBALS['CONFIG']["${module}.${key}"];
	}
	else
	{
		$GLOBALS['CONFIG']["${module}.${key}"] = $value;
	}
}

include('php/CONFIG.inc');
if(file_exists('/etc/murder/config.inc')) include('/etc/murder/config.inc');
if(file_exists('php/config.local.inc')) include('php/config.local.inc');

function safeGet($a, $k, $default='')
{
	if(isset($a) && is_array($a) && isset($a[$k]))
		return $a[$k];
	return $default;
}

function explodea($delimiter, $string, $limit=false)
{
	$r = 
		($limit===false?
			explode($delimiter, $string) :
			explode($delimiter, $string, $limit)
		);
	if(is_array($r)) return $r;
	else return array($r);
}

function getFirst($array)
{
	if(!$array || !is_array($array)) return $array;
	if(sizeof($array) > 0) return $array[0];
	return false;
}

function baseUrl()
{
	$https = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] && 'off' != $_SERVER['HTTPS']);
	$port  = (($https && $_SERVER['SERVER_PORT']!=443) || (!$https && $_SERVER['SERVER_PORT']!=80)) ? ':' . $_SERVER['SERVER_PORT'] : '';
	$schema = ($https?'https':'http');
	$host = $_SERVER['SERVER_NAME'];
	return  "${schema}://${host}${port}";
}

function redirect($location)
{
	$url = baseUrl() . $location;
	header("Location: ${url}");
}

function page() { return Page::getInstance(); }

function registerp($handlers, $prefix=false)
{
	PluginStore::getInstance()->addHandlers($handlers, $prefix);
}

function registerm($link, $text, $match='.')
{
	PluginStore::getInstance()->addMenu($match, $link, $text);
}

require_once('php/murder/murder.inc'); 
require_once('php/murder/auth.inc'); 
require_once('php/murder/mime.inc'); 
require_once('php/murder/plugin.inc'); 
require_once('php/murder/page.inc'); 
require_once('php/system/users.inc');
require_once('php/system/mail.inc');

?>
